/***************************************************************************
 *   Copyright (C) 2007 by Claudio Scafuri, Giacomo Strangolino   *
 *   claudio@hyo   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// cumbia
#include <cumbiapool.h>
#include <cuthreadfactoryimpl.h>
#include <qthreadseventbridgefactory.h>
#include <cuengineaccessor.h>
// cumbia

#include <quapplication.h>
#include "rfinp_b_sr.h"

int main( int argc, char ** argv ) {
    QuApplication qu_app( argc, argv );//	TApplication is mapped into QuApplication. DBus connection is provided by cumbia dbus plugin	//	 ## added by qumbiaprojectwizard
    CumbiaPool *cu_p = new CumbiaPool();
    RFInp *w = new RFInp(cu_p, 0);
    QString title("rfinp");
    if (qu_app.arguments().size() > 1)
        title = qu_app.arguments()[1].split('/').last(); /* solo il member */
    w->setWindowTitle(title);
    w->show();

    // exec application loop
    int ret = qu_app.exec();
    // delete resources and return
    // make sure to be operating on a valid cu_p in case of engine swap at runtime
    CuEngineAccessor *c = w->findChild<CuEngineAccessor *>();
    if(c)
        cu_p = c->cu_pool();
    delete w;

    for(std::string n : cu_p->names())
        if(cu_p->get(n))
            delete cu_p->get(n);

    return ret;


}

